#!/usr/bin/python

import dm

from maps import *
from device import RaidDev, RaidSet, BlockDev

_log_ignore = False
_verbose = dm.log_warn

def dm_log(level, file, line, message):
    if _log_ignore:
        return;
    if level == dm.log_fatal or level == dm.log_err:
        raise Exception, message
        #print "%s" % (message,)
        pass
    elif level == dm.log_warn:
        raise RuntimeWarning, message
        #print "%s" % (message,)
        pass
    elif level <= _verbose:
        print "%s" % (message,)
        pass

dm.set_logger(dm_log)
del dm_log

import dmraid
import bdevid

def getDevice(name):
    name = name.split('/')[-1]
    maps = dm.maps()
    for map in maps:
        if name == map.name:
            return (map.dev.major, map.dev.minor)

def DeviceMaps():
    mlist = dm.maps()
    devs = {}
    for m in mlist:
        devs[m.dev] = m
        
    maps = {}
    for d,m in devs.items():
        mdeps = filter(lambda x: devs.has_key(x), m.deps)
        for mdep in mdeps:
            key = devs[mdep]
            maps.setdefault(key, []).append(m)
    return maps

def removeDeviceMap(map):
    maps = DeviceMaps()
    try:
        for m in maps[map]:
            removeDeviceMap(m)
    except KeyError:
        pass
    map.remove()

def getRaidSets(*disks):
    # make it so you don't have to apply() to pass a list
    old = disks
    disks = []
    for disk in old:
        if isinstance(disk, [].__class__) or isinstance(disk,().__class__):
            disks += list(disk)
        else:
            disks.append(disk)
        
    c = dmraid.context()
    rsList = []
    prefix = "/dev/mapper/"
    
    newdisks = []
    import os as _os
    for x in range(len(disks)):
        if not disks[x].startswith('/'):
            devdisk = '/dev/' + disks[x]
            tmpdisk = '/tmp/' + disks[x]

            if _os.access(devdisk, _os.F_OK):
                disks[x] = devdisk
            elif _os.access(tmpdisk, _os.F_OK):
                disks[x] = tmpdisk
    del _os
    disks = disks + newdisks

    for rs in apply(c.get_raidsets, disks, {}):
        set = RaidSet(rs, prefix=prefix)
        if set.valid:
            rsList.append(set)
    return rsList

__all__ = [ "dm", "dmraid", "BlockDev" ]
